
APPLE SOURCE CODE FOR SENDDISK

(SORRY NO ASSEBMLER SOURCE, I WROTE IT IN THE MONITOR!)


SENDDISK   A$800, L$15D

0800- 4C FC 08  JMP $8FC    ;JUMP TO START OF PROGRAM

RWTS MODULE

0803- A9 08     LDA #$08    
0805- A0 0B     LDY $#0B    ;RWTS IOB POINTER TO $080B
0807- 20 09 3D  JSR $03D9   ;CALL RWTS
080A- 60        RTS         ;RETURN TO CALLER
080B- 01                    ;IOB TYPE
080C- 60                    ;SLOT 6
080D- 01                    ;DRIVE 1
080E- 00                    ;VOLUME NUMBER
080F- 00                    ;TRACK NUMBER
0810- 0F                    ;SECTOR NUMBER
0811- 1C 08                 ;DEVICE CHAR TABLE POINTER TO $081C
0813- 00 8F                 ;BUFFER POINTER $8F00
0815- 00 00                 ;UNUSED
0817- 01                    ;COMMAND CODE (1=READ)
0818- 00                    ;ERROR CODE (THIS BETTER BE 0!)
0819- FE                    ;ACTUAL VOLUME NUMBER FOUND
081A- 60                    ;PREVIOUS SLOT (6)
081B- 01                    ;PREVIOUS DRIVE (1)
081C- 00                    ;DCT TYPE CODE
081D- 01                    ;PHASES PER TRACK
081E- EF D8                 ;TIME COUNT

READ 7 TRACKS MODULE

0820- A9 8F     LDA #$8F    
0822- 8D 14 08  STA $0814   ;STORE START OF BUFFER
0825- A9 07     LDA #$07
0827- 85 43     STA #$43    ;STORE TRACK COUNTER (7 TRACKS)
0829- A9 0F     LDA #$0F
082B- 8D 10 08  STA $0810   ;STORE SECTOR $0F TO START THE TRACK
082E- 20 03 08  JSR $0803   ;CALL RWTS & READ THE SECTOR
0831- AD 0F 08  LDA $080F   ;GET THE TRACK NUMBER
0834- 85 24     STA $24     ;HTAB CURSOR TO TRACK NUMBER
0836- AD 10 08  LDA $0810   ;GET THE SECTOR NUMBER
0839- 20 E3 FD  JSR $FDE3   ;PRINT SECTOR NUMBER ON SCREEN
083C- CE 14 08  DEC $0814   ;DECREMENT BUFFER POINTER
083F- CE 10 08  DEC $0810   ;DECREMENT SECTOR
0842- 10 EA     BPL $082E   ;LOOP UNTIL TRACK IS READ
0844- CE 0F 08  DEC $080F   ;DECREMENT TRACK
0847- C6 43     DEC $43     ;DECREMENT TRACK COUNTER
0849- D0 DE     BNE $0829   ;LOOP UNTIL 7 TRACKS ARE READ
084B- 60        RTS         ;RETURN TO CALLER

SEND 7 PAGES UP SERIAL CARD MODULE

084C- A9 70     LDA #$70    ;SET $70 PAGES OF 256 BYTES TO SEND
084D- 85 44     STA $44     ;STORE IN PAGE COUNTER
0850- A9 00     LDA #$00
0852- 85 42     STA $42     ;CLEAR LSB OF BUFFER
0854- A9 20     LDA #$20
0856- 85 43     STA $43     ;STORE STARTING ADDRESS OF BUFFER ($2000)
0858- A0 00     LDY #$00    ;ZERO Y FOR INDEXED READ
085A- B1 42     LDA ($42),Y ;GET BYTE TO SEND
085C- AA        TAX         ;PUT BYTE TO SEND IN X
085D- 20 6B 08  JSR $086B   ;SEND THE BYTE
0860- E6 42     INC $42     ;INCREMENT BUFFER
0862- D0 F4     BNE $0858   ;LOOP UNTIL 1 PAGE SENT
0864- E6 43     INC $43     ;INCREMENT MSB OF BUFFER
0866- C6 44     DEC $44     ;DECREMENT PAGE COUNTER
0868- D0 EE     BNE $0858   ;LOOP UNTIL ALL PAGES SENT
086A- 60        RTS         ;RETURN TO CALLER

086B- 20 77 08  JSR $0877   ;CHECK ACIA STATUS
086E- D0 FB     BNE $086B   ;LOOP UNTIL TRANSMIT REGISTER IS CLEAR
0870- A0 99     LDA #$99    ;SET READ OFFSET 
0872- 8A        TXA         ;GET BYTE TO SEND FROM X
0873- 99 FF BF  STA $BFFF,Y ;WRITE BYTE TO $C089
0876- 60        RTS         ;RETURN TO CALLER
0877- AD 99 C0  LDA $C099   ;GET ACIA STATUS BYTE FROM SERIAL CARD
087A- 29 70     AND #$70    ;MASK OUT USELESS BITS
087C- C9 10     CMP #$10    ;SEE IF TRANSMIT REGISTER IS CLEAR
087E- 60        RTS         ;RETURN TO CALLER

WRITE OPENING SCREEN

087F- 20 58 FC  JSR $FC58   ;CLEAR SCREEN
0882- A0 00     LDY #$00    ;ZERO Y
0884- B9 90 08  LDA $0890,Y ;READ CHAR FROM $0890+
0887- 20 ED FD  JSR $FDED   ;PRINT CHAR
088A- C8        INY
088B- C0 60     CPY #$60
088D- D0 F5     BNE $0884   ;LOOP UNTIL $60 CHARS SENT
088F- 60        RTS         ;RETURN TO CALLER
    
0890- 30 30 30 30 30 30 30 30 30 30 30 30 30 30 30 30
08A0- 31 31 31 31 31 31 31 31 31 31 31 31 31 31 31 31
08B0- 32 32 32 8D 30 31 32 33 34 35 36 37 38 39 01 02
08C0- 03 04 05 06 30 31 32 33 34 35 36 37 38 39 01 02
08D0- 03 04 05 06 30 31 32 8D 8D 8D D0 D2 C5 D3 D3 A0 
08E0- C1 CE D9 A0 CB C5 D9 A0 D4 CF A0 D3 D4 C1 D2 D4
08F0- 8D 8D 8D              ;ASCII TEXT OF OPENING SCREEN

GET A KEYPRESS MODULE

08F3- 2C 10 C0  BIT $C010   ;CLEAR KEYBOARD STROBE
08F6- AD 00 C0  LDA $C000   ;READ KEYBOARD
08F9- 10 FB     BPL $08F6   ;UNTIL A KEY IS PRESSED
08FB- 60        RTS         ;RETURN TO CALLER

MAIN PROGRAM

08FC- 20 7F 08  JSR $087F   ;WRITE OPENING SCREEN
08FF- 20 F3 08  JSR $08F3   ;WAIT FOR KEYPRESS
0902- A9 22     LDA #$22
0904- 8D 0F 08  STA $080F   ;SET TRACKS TO READ AT $22
0907- A9 02     LDA #$02
0909- 85 25     STA $25     ;STORE CURSOR VERTICAL POSITION TO 2
090B- 20 22 FC  JSR $FC22   ;MOVE CURSOR VERTICAL
090E- 20 20 08  JSR $0820   ;READ 7 TRACKS
0911- 20 00 C1  JSR $C100   ;INITIALIZE SUPER SERIAL CARD
0914- 23 69     LDX #$69    ;OUR HEADER BYTE IS $69 (OF COURSE!)
0916- 20 6B 08  JSR $086B   ;SEND HEADER BYTE
0919- 20 4C 08  JSR $084C   ;SEND BUFFER UP SERIAL CARD
091C- AD 0F 08  LDA $080F   ;GET TRACK NUMBER
091F- C9 FF     CMP #$FF    ;CHECK TO SEE IF ALL TRACKS READ
0921- D0 EB     BNE $090E   ;REPEAT UNTIL ENTIRE DISK IS SENT

WRITE 'SEND ANOTHER DISK (Y/N)?' TO SCREEN

0923- A0 00     LDY #$00    ;ZERO Y
0925- B9 40 09  LDA $0940,Y ;GET CHAR AT $0940+
0928- 20 ED FD  JSR $FDED   ;SEND CHAR TO SCREEN
092B- C8        INY         
092C- C0 1C     CPY #$1C
092E- D0 F5     BNE $0925   ;LOOP UNTIL ALL CHARS SENT

GET Y/N RESPONSE

0930- 2C 10 C0  BIT $C010   ;CLEAR KEYBOARD STROBE
0933- AD 00 C0  LDA $C000   ;READ KEYBOARD
0936- 10 FB     BPL $0933   ;UNTIL KEY IS PRESSED
0938- C9 D9     CMP #$D9    ;IS IT A 'Y' ?
093A- F0 01     BEQ $093D   ;IF SO, LET'S DO ANOTHER DISK! (GRIN)
093C- 60        RTS         ;IF NOT - SEE YA LATER
093D- 4C FC 08  JMP $08FC   ;RESTART PROGRAM

0940- 8D 8D 8D 8D D3 C5 CE C4 A0 C1 CE CF D4 C8 C5 D2
0950- A0 C4 C9 D3 CB A0 A8 D9 AF CE A9 BF A0; TEXT OF 'ANOTHER DISK'



    
