LOAD OUT-09.ASM

BLOAD OUT-09.ASM,A$1800


!L
   1        ORG $1B00
   2        OBJ $800
   3 ;
   4 ;--->> OUT-09  VOICE & VIDEO
   5 ;
   6        NLS 
   7        JMP OUT
   8        JMP S/INIT
   9 ;
  10 ;
  11 SCR/TY EQU $1E08
  12 SCINIT EQU $E06
  13 ABORT  EQU $1E4E
  14 PRT/VC EQU $1E86
  15 CARWID EQU $1ED4
  16 FORMF  EQU $1ED5
  17 L|C051 EQU $C051
  18 L|C052 EQU $C052
  19 ;
  20 PRMON  ORA #$80
  21        JMP (PRT/VC)
  22 HIGH   HEX 00
  23 UFLG   HEX 00
  24 ;
  25 ;
  26 OUT    AND #$7F
  27        STA CHAR
  28        TYA 
  29        PHA 
  30        TXA 
  31        PHA 
  32        JSR DOIT
  33        PLA 
  34        TAX 
  35        PLA 
  36        TAY 
  37        RTS 
  38 ;
  39 ;
  40 DOIT   LDA #$FF
  41        STA $32
  42        LDA CHAR
  43        CMP #$0D
  44        BEQ CR
  45        CMP #$0C
  46        BEQ FF
  47        CMP #$08
  48        BEQ BACK
  49        LDX UFLG
  50        BMI UOUT
  51 ;
  52        LDX CCNT
  53        STA BUF,X
  54        INC CCNT
  55 NIX    RTS 
  56 CHAR   HEX 00
  57 FLASH  HEX 00
  58 CCNT   HEX 00
  59 DECL   HEX 00
  60 DECH   HEX 00
  61 LOPFIN HEX 00
  62 LIN/CT HEX 00
  63 ;
  64 BACK   LDA #$80
  65        STA UFLG
  66        LDX CCNT
  67        DEX 
  68        LDA BUF,X
  69        CMP #$60
  70        BCC BACKX
  71        XOR #$20
  72        STA BUF,X
  73 BACKX  RTS 
  74 UOUT   LDA #$00
  75        STA UFLG
  76        RTS 
  77 FF     JSR CRDO
  78        LDA #$00
  79        STA LIN/CT
  80        LDA FLASH
  81        BNE ZIP
  82 WAIT   JSR INPUT
  83        CMP #$20
  84        BNE WAIT
  85 ZIP    LDA #$0D
  86        JSR PRMON
  87        LDA #$0C
  88        JSR PRMON
  89        LDA #$00
  90        STA FLASH
  91        RTS 
  92 CR     JSR CRDO
  93        LDA HIGH
  94        CMP FORMF
  95        BEQ PATX
  96        BCS FINPR
  97 PATX   LDA LIN/CT
  98        JSR BLAH
  99        BNE FINPR
 100 WAIT2  JSR INPUT
 101        CMP #$0A
 102        BEQ FINPR
 103        CMP #$20
 104        BNE WAIT2
 105        LDA #$80
 106        STA FLASH
 107 ;
 108 FINPR  LDA CARWID
 109        CMP #$4C
 110        BEQ NOWAY
 111        LDA #$0D
 112        JSR PRMON
 113 NOWAY  RTS 
 114 ;
 115 CRDO   JSR BLANK
 116        INC LIN/CT
 117        LDA LIN/CT
 118        JSR BINDEC
 119        LDA DECH
 120        JSR PRMON
 121        LDA DECL
 122        JSR PRMON
 123        LDA #$7C
 124        JSR PRMON
 125 CRSKP  LDA $C030
 126        LDX #$FF
 127 CRLP   INX 
 128        CPX CARWID
 129        BEQ CRFIN
 130        LDA BUF,X
 131        JSR PRMON
 132        JMP CRLP
 133 CRFIN  LDA #$7C
 134        JSR PRMON
 135 CRFIN/ JMP ZERO
 136 ;
 137 BINDEC LDX #$30
 138        STX DECH
 139 BINX   CMP #$0A
 140        BCC BINY
 141        INC DECH
 142        SBC #$0A
 143        JMP BINX
 144 BINY   ADC #$30
 145        STA DECL
 146        RTS 
 147 S/INIT STA L|C051
 148        LDA #$00
 149        STA $22
 150        STA LIN/CT
 151        STA UFLG
 152        STA FLASH
 153        LDA #$0C
 154        JSR PRMON
 155 ZERO   LDY #$7F
 156        LDA #$20
 157 ZEROL  STA BUF,Y
 158        DEY 
 159        BPL ZEROL
 160        LDA #$00
 161        STA CCNT
 162        LDA #$18
 163        STA HIGH
 164        LDA CARWID
 165        CMP #$4D
 166        BCC ZERXX
 167        LDA #$0C
 168        STA HIGH
 169 ZERXX  RTS 
 170 BLAH   SEC 
 171        SBC HIGH
 172        BMI BLAHX
 173        BNE BLAH
 174 BLAHX  RTS 
 175 INPUT  LDY #$00
 176        LDA ($28),Y
 177        JSR $FD18
 178        AND #$7F
 179        CMP #$1B
 180        BNE NOESC
 181        STA ABORT
 182 NOESC  RTS 
 183 ;
 184 BLANK  LDY #$7F
 185 BL0    LDA BUF,Y
 186        CMP #$20
 187        BNE BLX
 188        DEY 
 189        BPL BL0
 190 BLX    INY 
 191        LDA #$7F
 192        STA BUF,Y
 193        RTS 
 194 ;
 195 TTYPE  LDA CARWID
 196        CMP #$30
 197        BCS TYPEX
 198        LDA FORMF
 199        CMP #$20
 200 TYPEX  RTS 
 201 ;
 202 ;
 203 XX     HEX 00
 204 BUF    HEX 00
 205        END 
!