LOAD OUT-0A.ASM

BLOAD OUT-0A.ASM,A$1800


!L
   1        ORG $1B00
   2        OBJ $800
   3 ;
   4 ;--->> OUT-0A LARGE PRINT
   5 ;
   6        NLS 
   7 ;
   8 BUF    EQU $3B08
   9 GRFBUF EQU $3B80
  10 PRT/VC EQU $1E86
  11 ;
  12        JMP OUT
  13        JMP LOADFT
  14 ;
  15 Z08    EPZ $08
  16 Z09    EPZ $09
  17 ZFE    EPZ $FE
  18 ALOW   EPZ $3E
  19 ;
  20 CONPT  EQU $1ED9
  21 PTYPE  EQU $1ED2
  22 AUTOLF EQU $1ED6
  23 DRIVE  EQU $E15
  24 ANDQQ  EQU $1E74
  25 Z1A    EPZ $1A
  26 Z1B    EPZ $1B
  27 CMPQQ  EQU $1E75
  28 DRV/LG EQU $1E56
  29 SLOT   EQU $1ED0
  30 CARDS  EQU $1E60
  31 ;
  32 ID     EQU $3B00
  33 FONTPT EQU $3B02
  34 NCOL   EQU $3B03
  35 NROW   EQU $3B04
  36 ;
  37 NSPAC  EQU $1EDE
  38 PARAM1 EQU $1EDC
  39 PARAM2 EQU $1EDD
  40 ;
  41 GRAPH  HEX 1B47
  42 DIG    HEX 30303030
  43 ;
  44 TYPE   EQU $330
  45 ROW    EQU $331
  46 COL    EQU $332
  47 WCHAR  EQU $333
  48 CHAR   EQU $334
  49 BCKFLG HEX 00
  50 TEMP   HEX 00
  51 CCNT   HEX 00
  52 ROW24  HEX 0018300000
  53 ;
  54 OUT    AND #$7F
  55        STA CHAR
  56        TYA 
  57        PHA 
  58        TXA 
  59        PHA 
  60        JSR DOIT
  61        PLA 
  62        TAX 
  63        PLA 
  64        TAY 
  65        RTS 
  66 ;
  67 DOIT   LDA CHAR
  68        CMP #$0D
  69        BEQ CR
  70        CMP #$0C
  71        BEQ FF
  72        CMP #$08
  73        BEQ BACK
  74        CMP #$20
  75        BCC NOCHAR
  76 ;
  77        LDX CCNT
  78        STA BUF,X
  79        INC CCNT
  80 NOCHAR RTS 
  81 FF     JSR CR
  82        LDA #$0C
  83        JSR OUT/8B
  84 ;
  85 CR     LDA #$00
  86        STA ROW
  87        JSR INSIDE
  88 ;
  89 CR1    LDA CCNT
  90        BNE REALCR
  91        JMP QUICK
  92 ;
  93 BACK   LDX CCNT
  94        DEX 
  95        BMI NOCHAR
  96        LDA BUF,X
  97        ORA #$80
  98        STA BUF,X
  99        RTS 
 100 ;
 101 REALCR LDA #$00
 102        STA WCHAR
 103        LDA #GRFBUF
 104        STA ZFE
 105        LDA /GRFBUF
 106        STA ZFE+1
 107        LDY #$03
 108 CRD1   LDA #$30
 109        STA DIG,Y
 110        DEY 
 111        BPL CRD1
 112 ;
 113 CR2    LDX WCHAR
 114        LDA BUF,X
 115        AND #$7F
 116        SEC 
 117        SBC #$20
 118        BCC SKIP
 119        STA ALOW
 120        LDA #$00
 121        STA ALOW+1
 122        JSR SHIFT
 123        JSR SHIFT
 124        JSR SHIFT
 125        LDA ALOW+1
 126        PHA 
 127        LDA ALOW
 128        PHA 
 129        JSR SHIFT
 130        JSR SHIFT
 131        JSR SHIFT
 132        CLC 
 133        PLA 
 134        ADC ALOW
 135        STA ALOW
 136        PLA 
 137        ADC ALOW+1
 138        ADC #$20
 139        STA ALOW+1
 140        LDA BUF,X
 141        BPL CR3
 142        LDA ALOW
 143        STA Z1A
 144        LDA ALOW+1
 145        STA Z1B
 146        LDA #$80
 147        STA BCKFLG
 148        JMP SKIP
 149 ;
 150 CR3    LDA #$00
 151        STA COL
 152 ;
 153 CR4    LDX ROW
 154        CLC 
 155        LDA ROW24,X
 156        ADC COL
 157        TAY 
 158        LDA BCKFLG
 159        BEQ CR77
 160        LDA (Z1A),Y
 161 CR77   ORA (ALOW),Y
 162        JSR PUTTB
 163 ;
 164        INC COL
 165        LDA COL
 166        CMP NCOL
 167        BNE CR4
 168 ;
 169        LDX NSPAC
 170        BEQ SKIP0
 171 CRXX   LDA #$00
 172        JSR PUTTB
 173        DEX 
 174        BNE CRXX
 175 ;
 176 SKIP0  LDA #$00
 177        STA BCKFLG
 178 SKIP   INC WCHAR
 179        LDA WCHAR
 180        CMP CCNT
 181        BEQ ZP/
 182        JMP CR2
 183 ;
 184 ZP/    JSR ZIPPY
 185 QUICK  LDA #$0D
 186        JSR OUT/8B
 187        LDA AUTOLF
 188        BEQ NOLF
 189        LDA #$0A
 190        JSR OUT/8B
 191 ;
 192 NOLF   INC ROW
 193        LDA ROW
 194        CMP NROW
 195        BEQ FINISH
 196        JMP CR1
 197 ;
 198 FINISH JSR OUTSID
 199        LDA #$0A
 200        JSR OUT/8B
 201        LDA #$00
 202        STA CCNT
 203        RTS 
 204 ;
 205 PUTTB  STX TEMP
 206        LDY #$00
 207        STA (ZFE),Y
 208        INC ZFE
 209        BNE PUTQ
 210        INC ZFE+1
 211        LDA ZFE+1
 212        CMP #$40
 213        BNE PUTQ
 214 NIX    LDA #$07
 215        JSR $FCA8
 216        LDA $C030
 217        JMP NIX
 218 PUTQ   LDX #$03
 219 PUTQ1  INC DIG,X
 220        LDA DIG,X
 221        CMP #$3A
 222        BNE PUTQ2
 223        LDA #$30
 224        STA DIG,X
 225        DEX 
 226        JMP PUTQ1
 227 PUTQ2  LDX TEMP
 228        RTS 
 229 ;
 230 SHIFT  ASL ALOW
 231        ROL ALOW+1
 232        RTS 
 233 SHIFTB LSR ALOW+1
 234        ROR ALOW
 235        RTS 
 236 ;
 237 OUT/FL LDY PTYPE
 238        CPY #$02
 239        BNE OUT/8B
 240        JSR FLIP
 241 ;
 242 OUT/8B LDY TYPE
 243        CPY #$0C
 244        BEQ GS
 245        CPY #$1C
 246        BEQ GS
 247        PHA 
 248 OUTNG  LDY #$00
 249        LDA ($FA),Y
 250        AND ANDQQ
 251        CMP CMPQQ
 252        BNE OUTNG
 253        PLA 
 254        STA ($FC),Y
 255        RTS 
 256 GS     JMP (PRT/VC)
 257 ;
 258 FLIP   LDY #$00
 259        STY TEMP
 260        LDY #$08
 261 OUTEL  LSR 
 262        ROL TEMP
 263        DEY 
 264        BNE OUTEL
 265        LDA TEMP
 266        RTS 
 267 ;
 268 ZEPSON LDA #$1B
 269        JSR OUT/8B
 270        LDA 'L
 271        JSR OUT/8B
 272        SEC 
 273        LDA ZFE
 274        SBC #GRFBUF
 275        PHP 
 276        JSR OUT/8B
 277        PLP 
 278        LDA ZFE+1
 279        SBC /GRFBUF
 280        JSR OUT/8B
 281        JMP ZAPP
 282 ;
 283 ZIPPY  LDA PTYPE
 284        CMP #$02
 285        BEQ ZEPSON
 286        LDX #$00
 287 GRX    LDA GRAPH,X
 288        JSR OUT/8B
 289        INX 
 290        CPX #$06
 291        BNE GRX
 292 ;
 293 ZAPP   LDA #GRFBUF
 294        STA ALOW
 295        LDA /GRFBUF
 296        STA ALOW+1
 297 LOOP   LDY #$00
 298        LDA (ALOW),Y
 299        JSR OUT/FL
 300        INC ALOW
 301        BNE LP2
 302        INC ALOW+1
 303 LP2    LDA ALOW+1
 304        CMP ZFE+1
 305        BNE LOOP
 306        LDA ALOW
 307        CMP ZFE
 308        BNE LOOP
 309        RTS 
 310 ;
 311 INSIDE LDX PTYPE
 312        LDA ISTAB,X
 313        JMP SNDX
 314 OUTSID LDX PTYPE
 315        LDA OUTAB,X
 316 SNDX   TAX 
 317 SNDXL  LDA SEQ,X
 318        CMP #$7F
 319        BEQ SNDXX
 320        JSR OUT/8B
 321        INX 
 322        BNE SNDXL
 323 SNDXX  RTS 
 324 ;
 325 ISTAB  HEX 000005
 326 OUTAB  HEX 000A0F
 327 SEQ    HEX 1B5431367F
 328        HEX 1B41087F7F
 329        HEX 1B5431367F
 330        HEX 1B41087F7F
 331 ;
 332 LOADFT LDX SLOT
 333        LDA CARDS,X
 334        STA TYPE
 335        CMP #$08
 336        BEQ FIX/SB
 337        CMP #$01
 338        BEQ FIX/SS
 339        CMP #$04
 340        BEQ FIX/2C
 341        BNE NOFIX
 342 FIX/SS LDA #$70
 343        STA $1E74
 344        BNE NOFIX
 345 FIX/2C LDA #$30
 346        STA $1E74
 347        BNE NOFIX
 348 FIX/SB LDA $1E70
 349        AND #$F0
 350        STA $1E70
 351        LDA $1E72
 352        AND #$F0
 353        STA $1E72
 354 NOFIX  JSR STUDY
 355        CMP ID
 356        BNE DOLOAD
 357        LDA CONPT
 358        CMP FONTPT
 359        BEQ LDQQ
 360 DOLOAD LDA #$01
 361        STA DRV/LG
 362        JSR DRIVE
 363        CLC 
 364        LDA CONPT
 365        ADC #$40
 366        STA LET
 367        LDY #$00
 368        STY $AA52
 369 LDFT   LDA DOS,Y
 370        BEQ LDQQ
 371        JSR PRDOS
 372        INY 
 373        BNE LDFT
 374 LDQQ   LDY #$03
 375 LDQQ1  LDA $1E70,Y
 376        STA $FA,Y
 377        DEY 
 378        BPL LDQQ1
 379        LDA #$00
 380        STA CCNT
 381        LDX PTYPE
 382        LDA OUTAB,X
 383        TAX 
 384        LDA PARAM1
 385        STA SEQ+2,X
 386        LDA PARAM2
 387        STA SEQ+3,X
 388        RTS 
 389 STUDY  LDY #$00
 390        LDA #$00
 391 STL    XOR $2000,Y
 392        DEY 
 393        BNE STL
 394        RTS 
 395 ;
 396 PRDOS  ORA #$80
 397        JMP $FDED
 398 ;
 399 DOS    HEX 84
 400        ASC 'BLOAD FONT-'
 401 LET    ASC 'Z'
 402        ASC ',A$2000'
 403        HEX 8D00
 404 ;
 405 XX     HEX 00
 406        END 
!