This outputs a line of material to an Imagewriter II on a serial port.
 
 
L
   1        ORG $7200
   2        OBJ $800
   3        NLS
   4 ;
   5 CHTL   EPZ $1A
   6 ;
   7 HSHAPE EQU $2100
   8 ;
   9 START  LDA #HSHAPE
  10        STA $06
  11        LDA /HSHAPE
  12        STA $07
  13 LOOP   LDY #$08
  14        LDA ($06),Y
  15        BEQ DONE
  16        JSR MOVE
  17        JSR TRANS
  18        LDA #$9B
  19        JSR PRMON
  20        LDA 'G
  21        JSR PRMON
  22        LDA '0
  23        JSR PRMON
  24        JSR PRMON
  25        JSR PRMON
  26        LDA '7
  27        JSR PRMON
  28        LDY #$00
  29 ILOOP  LDA TEMP,Y
  30        JSR PRGRPH
  31        INY
  32        CPY #$06
  33        BNE ILOOP
  34        LDA #$00
  35        JSR PRGRPH
  36        LDA #$20
  37        JSR PRMON
  38        JSR PRMON
  39        LDY #$08
  40        LDA ($06),Y
  41        JSR PRMON
  42        LDA #$20
  43        JSR PRMON
  44        LDY #$09
  45        LDA ($06),Y
  46        JSR PRMON
  47        LDA #$8D
  48        JSR PRMON
  49 ;
  50        CLC
  51        LDA $06
  52        ADC #$0A
  53        STA $06
  54        BCC LOOP
  55        INC $07
  56        BNE LOOP
  57 DONE   RTS
  58 TEMP   HEX 0000000000000000
  59 TX     HEX 0000000000000000
  60 MASK   HEX 0102040810204080
  61 ;
  62 MOVE   LDY #$07
  63 MOVE1  LDA ($06),Y
  64        STA TX,Y
  65        LDA #$00
  66        STA TEMP,Y
  67        DEY
  68        BPL MOVE1
  69        RTS
  70 TRANS  LDY #$00
  71 TR0    LDX #$00
  72 TR1    LSR TX,X
  73        BCC TR2
  74        LDA MASK,X
  75        ORA TEMP,Y
  76        STA TEMP,Y
  77 TR2    INX
  78        CPX #$07
  79        BNE TR1
  80        INY
  81        CPY #$07
  82        BNE TR0
  83        RTS
  84 ;
  85 PRMON  ORA #$80
  86        JMP $FDED
  87 ;
  88 QSLOT  HEX 9E
  89 QQ     HEX 00
  90 MSK2   HEX 50
  91 ;
  92 PRGRPH STY QQ
  93        LDY QSLOT
  94        PHA
  95 OUT    LDA $C089-$8E,Y
  96        AND MSK2
  97        CMP #$10
  98        BNE OUT
  99        PLA
 100        STA $C088-$8E,Y
 101        LDY QQ
 102        RTS
 103 ;
 104 XX     HEX 00
 105 ;
 106 ;
 107        END
!A
 
 
**END OF PASS 1
**END OF PASS 2
 
7200           1         ORG $7200
7200           2         OBJ $800
            107         END
 
 
***** END OF ASSEMBLY
 
 
 
          *************************
          *                       *
          * SYMBOL TABLE -- V 1.5 *
          *                       *
          *************************
 
LABEL. LOC.  LABEL. LOC.  LABEL. LOC.
 
** ZERO PAGE VARIABLES:
 
CHTL   001A
 
** ABSOLUTE VARABLES/LABELS
 
HSHAPE 2100  START  7200  LOOP   7208  ILOOP  7230  DONE   726D
TEMP   726E  TX     7276  MASK   727E  MOVE   7286  MOVE1  7288  TRANS  7296
TR0    7298  TR1    729A  TR2    72A8  PRMON  72B3  QSLOT  72B8  QQ     72B9
MSK2   72BA  PRGRPH 72BB  OUT    72C2  XX     72D4
 
SYMBOL TABLE STARTING ADDRESS:6000
SYMBOL TABLE LENGTH:00C2
 
 