LOADOUT-08.ASM
!LOAD OUT-08.ASM

BLOAD OUT-08.ASM,A$1800


!L
   1        ORG $1B00
   2        OBJ $800
   3 ;
   4 ;--->> OUT-08 VIDEO
   5 ;
   6        NLS 
   7        JMP OUT
   8        JMP S/INIT
   9 ;
  10 ;
  11 Z08    EPZ $08
  12 Z09    EPZ $09
  13 ABORT  EQU $1E4E
  14 CARWID EQU $1ED4
  15 FORMF  EQU $1ED5
  16 PRT/VC EQU $1E86
  17 L|C051 EQU $C051
  18 L|C052 EQU $C052
  19 BUF    EQU $9440
  20 ;
  21 PRMON  ORA #$80
  22        JMP (PRT/VC)
  23 ;
  24 ;
  25 OUT    AND #$7F
  26        STA CHAR
  27        TYA 
  28        PHA 
  29        TXA 
  30        PHA 
  31        JSR DOIT
  32        PLA 
  33        TAX 
  34        PLA 
  35        TAY 
  36        RTS 
  37 ;
  38 ;
  39 DOIT   LDA #$FF
  40        STA $32
  41        LDA CHAR
  42        CMP #$0D
  43        BEQ CR
  44        CMP #$0C
  45        BEQ FF
  46 ;
  47        LDX CCNT
  48        STA BUF,X
  49        INC CCNT
  50 NIX    RTS 
  51 CHAR   HEX 00
  52 FLASH  HEX 00
  53 CCNT   HEX 00
  54 LIN/CT HEX 00
  55 DECL   HEX 00
  56 DECH   HEX 00
  57 LOPFIN HEX 00
  58 FF     JSR CRDO
  59        LDA #$00
  60        STA LIN/CT
  61        LDA FLASH
  62        BNE ZIP
  63 WAIT   LDA $C000
  64        BPL WAIT
  65        JSR FLAKE
  66        CMP #$A0
  67        BNE WAIT
  68 ZIP    LDX $C010
  69        LDA #$0D
  70        JSR PRMON
  71        JSR LINE
  72        LDA #$00
  73        STA FLASH
  74        RTS 
  75 CR     JSR CRDO
  76        LDX FORMF
  77        CPX #$19
  78        BCC CRON
  79        LDX LIN/CT
  80        CPX #$18
  81        BNE CRON
  82 WAIT2  LDA $C000
  83        BPL WAIT2
  84        LDX $C010
  85        JSR FLAKE
  86        CMP #$8A
  87        BEQ CRON
  88        CMP #$A0
  89        BNE WAIT2
  90        LDA #$80
  91        STA FLASH
  92 CRON   LDA LIN/CT
  93        CMP #$17
  94        BCS FINPR
  95        ASL 
  96        TAX 
  97        LDA TABLE,X
  98        STA Z08
  99        LDA TABLE+1,X
 100        STA Z09
 101        BEQ FINPR
 102        LDA #$20
 103        JSR PRMON
 104        JSR PRMON
 105        LDY #$00
 106 PRLOOP LDA (Z08),Y
 107        BEQ FINPR
 108        CMP '  
 109        BEQ PGNUM
 110        JSR PRMON
 111        INY 
 112        JMP PRLOOP
 113 ;
 114 ;
 115 PGNUM  LDA $1E6F
 116        LDX #$00
 117 PG1    CMP #$0A
 118        BCC PG2
 119        SBC #$0A
 120        INX 
 121        BNE PG1
 122 PG2    PHA 
 123        TXA 
 124        ORA #$30
 125        JSR PRMON
 126        PLA 
 127        ORA #$30
 128        JSR PRMON
 129 FINPR  LDA #$0D
 130        JSR PRMON
 131        RTS 
 132 ;
 133 CRDO   INC LIN/CT
 134        LDA LIN/CT
 135        JSR BINDEC
 136        LDA DECH
 137        JSR PRMON
 138        LDA DECL
 139        JSR PRMON
 140        LDA #$20
 141        JSR PRMON
 142        JSR PRMON
 143        LDA #$7F
 144        JSR PRMON
 145        JSR PRMON
 146        LDX #$FF
 147 CRLP   INX 
 148        CPX CARWID
 149        BEQ CRFIN
 150        LDA BUF,X
 151        JSR PRMON
 152        JMP CRLP
 153 CRFIN  LDA #$7F
 154        JSR PRMON
 155        JSR PRMON
 156        JSR ZERO
 157        RTS 
 158 BINDEC LDX #$30
 159        STX DECH
 160 BINX   CMP #$0A
 161        BCC BINY
 162        INC DECH
 163        SBC #$0A
 164        JMP BINX
 165 BINY   ADC #$30
 166        STA DECL
 167        RTS 
 168 LINE   CLC 
 169        LDA CARWID
 170        ADC #$07
 171        TAY 
 172        LDA #$7F
 173 LIN1   JSR PRMON
 174        DEY 
 175        BPL LIN1
 176        LDA #$0D
 177        JSR PRMON
 178        RTS 
 179 S/INIT STA L|C051
 180        LDA #$00
 181        STA LIN/CT
 182        STA $22
 183        LDA #$0C
 184        JSR PRMON
 185 ZERO   LDY #$3F
 186        LDA #$20
 187 ZEROL  STA BUF,Y
 188        DEY 
 189        BPL ZEROL
 190        LDA #$00
 191        STA CCNT
 192        RTS 
 193 FLAKE  CMP #$9B
 194        BNE NOESP
 195        STA ABORT
 196 NOESP  RTS 
 197 ;
 198 TABLE  HEX 0000
 199        HEX 0000
 200        HEX 0000
 201        ADR LIT1
 202        ADR LIT2
 203        HEX 0000
 204        ADR LIT3
 205        ADR LIT4
 206        HEX 0000
 207        HEX 0000
 208        ADR NUM1
 209        ADR NUM2
 210        HEX 0000
 211        ADR COM1
 212        ADR COM2
 213        ADR COM3
 214        ADR COM4
 215        ADR COM5
 216        ADR COM6
 217        ADR COM7
 218        HEX 0000
 219        HEX 0000
 220        ADR COM9
 221        HEX 0000
 222 LIT1   ASC 'Hit the spacebar to view'
 223        HEX 00
 224 LIT2   ASC '    the next page.'
 225        HEX 00
 226 LIT3   ASC 'Hit the down arrow to view'
 227        HEX 00
 228 LIT4   ASC '    the rest of the page.'
 229        HEX 00
 230 NUM1   ASC 'numbers are dropped a-j'
 231        HEX 00
 232 NUM2   ASC '  (Nemeth numbers)'
 233        HEX 00
 234 COM1   ASC '!=the "=dot 5 #=# $=ed %=sh'
 235        HEX 00
 236 COM2   ASC "&=and '=dot 3 (=of )=with"
 237        HEX 00
 238 COM3   ASC '*=ch +=ing ,=dot 6 -=com'
 239        HEX 00
 240 COM4   ASC '.=dots 4-6 /=st :=wh'
 241        HEX 00
 242 COM5   ASC '<=gh ==for >=ar ?=th @=dot 4'
 243        HEX 00
 244 COM6   ASC '[=ow \=ou ]=er ^=dots 4-5'
 245        HEX 00
 246 COM7   ASC '_= dots 4-5-6 ;=dots 5-6'
 247        HEX 00
 248 COM9   ASC 'BEX page   '
 249 XX     HEX 00
 250        END 
!