This program moves chunks of memory back and forth between Main and AUX
memory on the Apple II. It helps put the character table in AUX memory.
 
First poke locations $1EED (which transition) (see below)
                     $1EEF (which direction 0=to main, 1=to aux)
 
1 - keyboard mode to 7200
2  - math translator into 7200
3 - math translation table into 2000
4 - literary translation table into 3000
5  - display program into 7200
6 - page file into 8200
 
!L
   1        ORG $9200
   2        OBJ $800
   3 ;
   4 ; ----->>> MOD15
   5 ;
   6        NLS
   7 ;
   8        JMP MEMOVE
   9        JMP PRO
  10 ;
  11 MEM/WH EQU $1EED
  12 MEM/DR EQU $1EEF
  13 AUXMOV EQU $C311
  14 ;
  15 ;
  16 MEMOVE LDY #$00
  17        STY $C000
  18        STY $3C
  19        STY $42
  20        LDA MEM/WH
  21        ASL
  22        TAX
  23        LDA TB,X
  24        STA $3D
  25        LDA TB+1,X
  26        STA $43
  27        LDY MEM/WH
  28        BEQ TOMAIN
  29        STA $3D
  30        LDA TB,X
  31        STA $43
  32 TOMAIN CLC
  33        LDA $3D
  34        ADC #$0F
  35        STA $3F
  36        LDA #$FF
  37        STA $3E
  38 ;
  39        LDA MEM/DR
  40        ROR
  41        JSR AUXMOV
  42        RTS
  43 ;
  44 TB     HEX 0000
  45        HEX 1072
  46        HEX 2072
  47        HEX 3020
  48        HEX 4030
  49        HEX 5072
  50        HEX 6082
  51 ;
  52 ;
  53 PRO    LDA #$06
  54        STA MEM/WH
  55        LDA #$01
  56        STA MEM/DR
  57        JSR MEMOVE
  58        LDA #$02
  59        STA MEM/WH
  60        LDA #$00
  61        STA MEM/DR
  62        JSR MEMOVE
  63        LDA #$03
  64        STA MEM/WH
  65        JSR MEMOVE
  66        LDA #$04
  67        STA MEM/WH
  68        JSR MEMOVE
  69        JSR $7200
  70        LDA #$05
  71        STA MEM/WH
  72        JSR MEMOVE
  73        LDA #$00
  74        STA $7205
  75        JSR $7200
  76        LDA #$01
  77        STA MEM/WH
  78        JSR MEMOVE
  79        JMP $7200
  80 ;
  81 XX     HEX 00
  82        END
  83 ;
!LOAD UNLINK.ASM
 
BLOAD UNLINK.ASM,A$1800
 
 
!L
   1        ORG $3280
   2        OBJ $800
   3        NLS
   4 ;
   5 ;
   6 UNLINK LDY #$03
   7 UNL    LDA $1E88,Y
   8        LDX $1E02
   9        BNE REVOC
  10        LDA CONST,Y
  11 REVOC  STA $AA53,Y
  12        DEY
  13        BPL UNL
  14        JSR $A851
  15        LDX $1E02
  16        BEQ NT/SLT
  17        LDX $1E09
  18        CPX #$01
  19        BNE NT/ECH
  20        LDA #$85
  21        JSR $FDED
  22        LDA "B
  23        JSR $FDED
  24        BNE NT/SLT
  25 NT/ECH CPX #$03
  26        BNE NT/SLT
  27        LDA #$85
  28        JSR $FDED
  29        LDA "3
  30        JSR $FDED
  31        LDA "E
  32        JSR $FDED
  33 NT/SLT LDA #$00
  34        STA $06
  35        STA $08
  36        LDA #$20
  37        STA $07
  38        LDA #$08
  39        STA $08
  40 MV1    LDY #$00
  41 MV2    LDA ($06),Y
  42        STA ($08),Y
  43        INY
  44        BNE MV2
  45        INC $07
  46        INC $09
  47        LDA $07
  48        CMP #$33
  49        BNE MV1
  50        RTS
  51 ;
  52 ;
  53 CONST  HEX F0FD1BFD
  54        END
 
 
 