This is just the braille keyboard program for the Apple II
 
 
!L
   1        ORG $7200
   2        OBJ $800
   3 ;
   4 ;------>>> MOD16
   5 ;
   6        NLS
   7        JMP START
   8 ;
   9 Z06    EPZ $06
  10 BEEP   EQU $FBDD
  11 ;
  12 BC1    HEX 00
  13 BC2    HEX 00
  14 BC3    HEX 00
  15 CF     HEX 00
  16 BCB    HEX 00
  17 DAT/FG HEX 00
  18 ;
  19 START  JSR SETUP
  20 LOOP   JSR KEY/B0
  21        LDX DAT/FG
  22        BEQ PUT
  23        CPX 'O
  24        BEQ OUTPUT
  25        CPX #$08
  26        BEQ BACKSP
  27        CPX 'Q
  28        BEQ QUIT
  29 ;
  30 PUT    LDY #$00
  31        STA (Z06),Y
  32        JSR INC06
  33        JMP LOOP
  34 ;
  35 QUIT   RTS
  36 OUTPUT JMP $9203
  37 BACKSP LDA Z06
  38        BNE BACK1
  39        LDA Z06+1
  40        CMP #$82
  41        BEQ BACK/E
  42 BACK1  LDA Z06
  43        BNE BACK3
  44        DEC Z06+1
  45 BACK3  DEC Z06
  46        RTS
  47 BACK/E JMP BEEP
  48 ;
  49 ;
  50 ;
  51 KEY/B0 LDY #$00
  52        STY BCB
  53        STY BC3
  54        STY DAT/FG
  55        DEY
  56 BRL/KL STY CF
  57 BRL/CL LDY #$F7
  58        STY BC1
  59        STY BC2
  60 BRL/IL LDA $C000
  61        BMI BRL/CF
  62        INC BC1
  63        BNE BRL/IL
  64        INC BC2
  65        BNE BRL/IL
  66        LDY BC3
  67        BEQ KEY/B0
  68        LDY BCB
  69        BEQ REAL/S
  70        LDA BRL,Y
  71        AND CF
  72 BRL/FN RTS
  73 REAL/S LDA #$20
  74        BNE BRL/FN
  75 BRL/CF INC BC3
  76        LDX $C010
  77        AND #$7F
  78        CMP #$20
  79        BEQ BRL/SP
  80        BCC BRL/FN
  81        LDY #$06
  82 CZ4    CMP BRTB2,Y
  83        BEQ CZ3
  84        DEY
  85        BPL CZ4
  86        LDY #$02
  87 ZQ6    CMP SPTB,Y
  88        BEQ LEAVE
  89        DEY
  90        BPL ZQ6
  91        JSR BEEP
  92        JMP KEY/B0
  93 CZ3    LDA BRTB3,Y
  94        ORA BCB
  95        STA BCB
  96        JMP BRL/CL
  97 BRL/SP LDY #$1F
  98        BNE BRL/KL
  99 LEAVE  STA DAT/FG
 100        RTS
 101 ;
 102 BRTB3  HEX 00
 103        HEX 010204081020
 104 BRTB2  ASC ' '
 105        ASC 'FDSJKL'
 106 SPTB   HEX 08
 107        ASC 'OQ'
 108 ; Braille Keyboard Table
 109 ;
 110 BRL    HEX 20613162276B326C
 111        HEX 406369662F6D7370
 112        HEX 22653368396F3672
 113        HEX 5E646A673E6E7471
 114        HEX 2C2A353C2D753876
 115        HEX 2E255B242B782126
 116        HEX 3B3A345C307A3728
 117        HEX 5F3F775D2379293D
 118 ;
 119 SETUP  LDA #$00
 120        STA Z06
 121        LDA #$82
 122        STA Z06+1
 123        RTS
 124 INC06  INC Z06
 125        BNE INC0
 126        INC Z06+1
 127 INC0   RTS
 128 ;
 129 ;
 130        END
!A
 
 
**END OF PASS 1
**END OF PASS 2
 
7200           1         ORG $7200
7200           2         OBJ $800
7200           3  ;
7200           4  ;------>>> MOD16
7200           5  ;
            130         END
 
 
***** END OF ASSEMBLY
 
 
 
          *************************
          *                       *
          * SYMBOL TABLE -- V 1.5 *
          *                       *
          *************************
 
LABEL. LOC.  LABEL. LOC.  LABEL. LOC.
 
** ZERO PAGE VARIABLES:
 
Z06    0006
 
** ABSOLUTE VARABLES/LABELS
 
BEEP   FBDD  BC1    7203  BC2    7204  BC3    7205  CF     7206
BCB    7207  DAT/FG 7208  START  7209  LOOP   720C  PUT    7220  QUIT   722A
OUTPUT 722B  BACKSP 722E  BACK1  7238  BACK3  723E  BACK/E 7241  KEY/B0 7244
BRL/KL 7250  BRL/CL 7253  BRL/IL 725B  BRL/FN 727A  REAL/S 727B  BRL/CF 727F
CZ4    728F  ZQ6    7299  CZ3    72A7  BRL/SP 72B3  LEAVE  72B7  BRTB3  72BB
BRTB2  72C2  SPTB   72C9  BRL    72CC  SETUP  730C  INC06  7315  INC0   731B
 
 
SYMBOL TABLE STARTING ADDRESS:6000
SYMBOL TABLE LENGTH:0132
 
 
!