/*  Catalog and File Grabber for *.dsk Apple Image files 02/28/2000 */

	#include <stdio.h>
	#include <string.h>
	#include <stdlib.h>
	#include <io.h>
	#include <process.h>

int c,i,j,k,off,d,yy,d2,sr,ptr,max,page,pages,let,first,count,sizep;
int trk,sectn,seq=1,cat,fnd_trk,fnd_sectn,fnd_ty;
long pos,filesz;

char sect[257],buffer[40],list[257],bex[140];
void sector(void);
void dirsect(void);
void dodir(void);

FILE *infile, *outfile;
fpos_t startpos,newpos;

void main(int argc,char *argv[])
{

	if (argc==1) {printf("\n\nGRABA2 reads 143,360 byte Apple 2 DOS 3.3 disk images");
	printf("\nUse SENDDISK on the Apple 2 and GETDISK on the PC to");
	printf("\n  obtain Apple 2 disk image files on the PC.");
	printf("\n\nGRABA2 [PC file] displays the disk catalog");
	printf("\nGRABA2 [PC file] [Apple file] save Apple 2 file as a PC file");
	printf("\nUse a ~ for a space in the file name:");
	printf("\n  GRABA2 X.DSK FREDS~PETS <Enter> instead of GRABA2 X.DSK FREDS PETS <Enter>");
	printf("\nAdd a third parameter BEX if it is a BEX Chapter");
	printf("\n  Example:  GRABA2 X.DSK FRED BEX <Enter>\n");
	return;
}
	if ((infile=fopen(argv[1],"rb"))==NULL)
	{
		printf("\n\nCannot open source Apple Image file.");
		printf("\nCheck the PC file name of the Apple Image file.\n");
		exit(1);
	}
	filesz=filelength(fileno(infile));
	if ((filesz/256)!=560)
	{
		printf("\n\nApple Image file must be 143,360 bytes long exactly.");
		printf("\nUse SENDDISK on the Apple 2 and GETDISK on the PC to");
		printf("\nobtain Apple 2 disk image files on the PC.");
		exit(1);
	}

if (argc==2) {printf("Apple DOS 3.3 Catalog\n"); cat=1;}
if (!cat) 
{
	strcpy(&buffer[0],&argv[2][0]);
 max=0; while(buffer[max]) 
	{
		c=buffer[max++]; 
		if ((c>96)&&(c<123)) buffer[max-1]=c-32; 
		if (c=='~') buffer[max-1]=' ';
	}
	j=0; while(argv[2][j]) 
	{
		c=argv[2][j++]; 
		if ((c=='~')||(c=='/')) argv[2][j-1]='-';
	}	
	if ((outfile=fopen(argv[2],"wb"))==NULL)
	{
		fprintf(stderr,"Cannot open target PC file:%s\n",&argv[2][0]);
		exit(1);
	}

}

sectn=15,trk=17,sect[1]=trk,sect[2]=sectn;
dodir(); if (cat) {printf("\n"); return;}
if (!cat&&!fnd_trk) {printf("\nApple File Not Found"); return;}
if (fnd_ty>128) fnd_ty=fnd_ty-128;
first=fnd_ty;
if ((fnd_ty<4)&&(argc==3))
{
	trk=fnd_trk,sectn=fnd_sectn; sector();
	j=0; while(j<256) list[j]=sect[j++];
	ptr=12,seq=0;
	while (list[ptr]||list[ptr+1])
	{
		trk=list[ptr++],sectn=list[ptr++];
		sector();
		j=first, first=0; 
		while(j<256) 
		{
			c=sect[j++]; 
			if (c>128) c=c-128; 
			if (c<0) c=c+128;
			if (c) {fputc(c,outfile);}
			if (c==13) fputc(10,outfile);
		}
	}
}
else
{
	trk=fnd_trk,sectn=fnd_sectn; sector();
	j=0; while(j<256) list[j]=sect[j++];
	ptr=12,seq=0;
	trk=list[ptr++],sectn=list[ptr++];
	sector();
	j=0; while (j<130) bex[j]=sect[j++];
 pages=bex[4];
 page=1; while (page<=pages)
	{
			let=bex[(3*page)+4]+64;
			j=bex[(3*page)+5]; if (j<0) j=j+128;
			sizep=j+(256*bex[(3*page)+6]);
			if (sizep)
			{
				buffer[max]='.',buffer[max+1]=let,buffer[max+2]=0;
				sectn=15,trk=17,sect[1]=trk,sect[2]=sectn;
				dodir();
				if (!fnd_trk) {printf("\nFile Found"); return;}
				if (fnd_ty>128) fnd_ty=fnd_ty-128;
				first=fnd_ty,count=0;
			 fputc(13,outfile);
			 fputc(10,outfile);
			 fputc(13,outfile);
			 fputc(10,outfile);

					trk=fnd_trk,sectn=fnd_sectn; sector();
					j=0; while(j<256) list[j]=sect[j++];
					ptr=12,seq=0;
					while (list[ptr]||list[ptr+1])
					{
						trk=list[ptr++],sectn=list[ptr++];
						sector();
						j=first, first=0; 
						while(j<256) 
						{
							c=sect[j++],count++; 
							if (sizep==count) j=256;
							if (c>128) c=c-128; 
							if (c<0) c=c+128;
							if (c) {fputc(c,outfile);}
							if (c==13) fputc(10,outfile);
						}
						
					}
			}
			page++;
	}

}

printf("\nDone Writing file");
fclose(infile);
fclose(outfile);
}

void sector()
{
	pos=(16*trk)+sectn; newpos=pos*256;
	fsetpos(infile,&newpos);
	i=0; while (i<256) {c=fgetc(infile); sect[i++]=c;}
}


void dirsect()
{
	trk=sect[1],sectn=sect[2];
	sector();
	j=0,off=14; 
	while (j<7)
	{
 		d=sect[off+(j*35)],d2=sect[off+29+(j*35)];
		 if (cat&&d&&(d2==-96))
			{
				printf("\n%i  ",seq++);
				k=0; while (k<30) {d=sect[off+(j*35)+k++]-128; printf("%c",d);}
				printf("%c t=%i s=%i",42,sect[off-3+(j*35)],sect[off-2+(j*35)]);
			}
		 if ((!cat)&&d&&(d2==-96))
			{
				sr=1; k=0; while ((k<30)&&buffer[k]) {d=sect[off+(j*35)+k++]+128; if (d!=buffer[k-1]) sr=0;}
				if (sr) while (k<22) {d=sect[off+(j*35)+k++]+128; if (d!=32) sr=0;}
				if (sr) i=off+(j*35),fnd_trk=sect[i-3],fnd_sectn=sect[i-2],fnd_ty=sect[i-1];
 	  if (sr) return;
			}
			j++;
	}

	trk=sect[1],sectn=sect[2];
}


void dodir()
{
while (trk&&sectn) dirsect(); 
}
